function showCalendar(name, type) {
   drawCalendar(name, type, getSelectedDate(name).getTime());
   document.getElementById(name + "_modal-background").style.display = "block";
}

function hideCalendar(name) {
   document.getElementById(name + "_modal-background").style.display = "none";
}

function getSelectedDate(name) {
   var time = document.getElementById(name).value;
   if (time == "undefined") {
      return new Date();
   }
   else {
      var year = time.substring(0, 4);
      var month = time.substring(5, 7) - 1;
      var day = time.substring(8, 10);
      var hours = time.substring(11, 13);
      var minutes = time.substring(14, 16);
		return new Date(year, month, day, hours, minutes);
   }
}

function updateTime(name, type, timestamp) {
   var value = "";
   var date = new Date(timestamp);
   value += date.getFullYear();
   var month = (date.getMonth() < 9) ? "0" + (date.getMonth() + 1) : date.getMonth() + 1;
   value += "-" + month;
   var day = (date.getDate() < 10) ? "0" + date.getDate() : date.getDate();
   value += "-" + day;
   if (type == "datetime") {
      var hours = (date.getHours() < 10) ? "0" + date.getHours() : date.getHours();
      value += " " + hours;
      var minutes = (date.getMinutes() < 10) ? "0" + date.getMinutes() : date.getMinutes();
      value += ":" + minutes;
   }
   document.getElementById(name).value = value;
   showCalendar(name, type);
}

function nextMonth(name, type, timestamp) {
   var date = new Date(timestamp);
   date.setDate(1);
   date.setMonth(date.getMonth() + 1);
   drawCalendar(name, type, date.getTime());
}

function prevMonth(name, type, timestamp) {
   var date = new Date(timestamp);
   date.setDate(1);
   date.setMonth(date.getMonth() - 1);
   drawCalendar(name, type, date.getTime());
}

function nextYear(name, type, timestamp) {
   var date = new Date(timestamp);
	date.setDate(1);
   date.setYear(date.getFullYear() + 1);
   drawCalendar(name, type, date.getTime());
}

function prevYear(name, type, timestamp) {
   var date = new Date(timestamp);
	date.setDate(1);
   date.setYear(date.getFullYear() - 1);
   drawCalendar(name, type, date.getTime());
}

function drawCalendar(name, type, timestamp) {
   //setup our variables
   var date = new Date(timestamp);
   var daysInMonth = new Date(date.getFullYear(), date.getMonth() + 1, 0).getDate();
   var current_day = new Date().getDate();
   var current_month = new Date().getMonth();
   var current_year = new Date().getYear();
   var selected_date = getSelectedDate(name);
   var selected_hour = selected_date.getHours();
   var selected_minute = selected_date.getMinutes();
   var selected_day = selected_date.getDate();
   var selected_month = selected_date.getMonth();
   var selected_year = selected_date.getYear();
   var month = ["Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"];

   var output = "<table>";
	output += "<tr>";
	output += "<td colspan='3'>";

   if (type == "datetime") {
      output += "<select onchange='eval(this.options[this.selectedIndex].getAttribute(\"onclick\"));'>";
      for (var i = 0; i < 24; i++) {
         selected_date.setHours(i);
         output += "<option id=''value='" + i + "'";
         if (i == selected_hour) {output += " selected";}
         output += " onClick='updateTime(\"" + name + "\", \"" + type + "\", " + selected_date.getTime() + ");'>";
         if (i == 0) {output += "12AM";}
         else if (i > 12) {output += (i - 12) + " PM";}
			else if (i == 12) {output += i + " PM";}
         else {output += i + " AM";}
         output += "</option>";
      }
      selected_date.setHours(selected_hour);
      output += "</select> <strong>:</strong> ";
      output += "<select onchange='eval(this.options[this.selectedIndex].getAttribute(\"onclick\"));'>";
      for (var i = 0; i < 60; i++) {
         selected_date.setMinutes(i);
         output += "<option value='" + i + "'";
         if (i == selected_minute) {output += "selected";}
         output += " onClick='updateTime(\"" + name + "\", \"" + type + "\", " + selected_date.getTime() + ");'>";
         if (i < 10) {output += "0" + i}
         else {output += i;}
         output += "</option>";
      }
      output += "</select>";
   }
   else {
      output += "&nbsp;";
   }

   output += "</td>";
   output += "<td>&nbsp;</td>";
   output += "<td colspan='3'>";
   output += "<a href='javascript: hideCalendar(\"" + name + "\");'>Close Window</a>";
   output += "</td>";
   output += "</tr>";

   output += "<tr>";
   output += "<th class='clickable' onclick='prevYear(\""+name+"\", \""+type+"\", "+timestamp+");'>&lt;&lt;</th>";
   output += "<th class='clickable' onclick='prevMonth(\""+name+"\", \""+type+"\", "+timestamp+");'>&lt;</th>";
   output += "<th colspan='3'>"+month[date.getMonth()]+", "+date.getFullYear()+"</th>";
   output += "<th class='clickable' onclick='nextMonth(\""+name+"\", \""+type+"\", "+timestamp+");'>&gt;</th>";
   output += "<th class='clickable' onclick='nextYear(\""+name+"\", \""+type+"\", "+timestamp+");'>&gt;&gt;</th>";
   output += "</tr>";

   output += "<tr>";
   output += "<td class='day-header'>S</td>";
   output += "<td class='day-header'>M</td>";
   output += "<td class='day-header'>T</td>";
   output += "<td class='day-header'>W</td>";
   output += "<td class='day-header'>T</td>";
   output += "<td class='day-header'>F</td>";
   output += "<td class='day-header'>S</td>";
   //pad out the first row, if the first day is not sunday
   date.setDate(1);
   output += "</tr>";

   if (date.getDay() > 0) {
      output += "<td colspan='" + date.getDay() + "' class='weekday'><p>&nbsp;</p></td>";
   }
   for (var day = 1; day <= daysInMonth; day++) {
      //update our date object
      date.setDate(day);
      //satart our date square
      output += "<td class='";
      //check for weekendness
      if (date.getDay() == 0 || date.getDay() == 6) {
         output += "weekend";
      }
      else {
         output += "weekday";
      }
      //check for today
      if (date.getDate() == current_day && date.getMonth() == current_month && date.getYear() == current_year) {
         output += " today";
      }
      if (date.getDate() == selected_day && date.getMonth() == selected_month && date.getYear() == selected_year) {
         output += " selected-day";
      }

      output += " clickable' onClick='updateTime(\"" + name + "\", \"" + type + "\", " + date.getTime() + ");'>";
      output += "<p>" + date.getDate() + "</p>";
      output += "</td>";

      //figure out if we need to close the row
      if (date.getDay() == 6) {
         output += "</tr>";
      }
   }
   //end the month, padding out the row and closing it if necessary
   if (date.getDay() < 6) {
      output += "<td colspan='" + (6 - date.getDay()) + "'><p>&nbsp;</p></td></tr>";
   }
   output += "</table>";
   document.getElementById(name + "_calendar").innerHTML = output;
}
