<?php
   $instructions = "Comma separated list of property names.  Whitespace-insensitive, no $ allowed.";
   if (!empty($_POST)) {
      //add our method
      $plugin = $_GET["plugin"];
      $class = $_GET["class"];
      $method = slugify($_POST["method"]);
      $visibility = $_POST["visibility"];
      $scope = $_POST["scope"];
      if ($_POST["arguments"] == $instructions || empty($_POST["arguments"])) {
         $arguments = "";
      }
      else {
         $arguments = explode(",", $_POST["arguments"]);
         foreach ($arguments as $index=>$argument) {
            $arguments[$index] = "$" . slugify(trim($argument));
         }
         $arguments = implode(", ", $arguments);
      }
      $type = $_POST["type"];
      $plugin_dir = ABSPATH . "wp-content/plugins/$plugin";
      $class_dir = "$plugin_dir/classes/$class";

      //build the function signature, and create the required directory structure
      $signature = "\t\t/**\n\t\t *\n\t\t */\n\t\t";
      $signature .= "$visibility$scope function $method($arguments) {\n";
      if ($type == "view") {
         $signature .= "\t\t\tinclude(__DIR__ . \"/views/$method.php\");\n";
         $signature .= "\t\t\treturn " . '$output;';
         make_stub("$class_dir/views/$method.php");
			file_put_contents("$class_dir/views/$method.php", "//The output of this file is saved as a variable because it will be returned to the WordPress shortcode.  It is perfectly acceptable to echo your output directly if this view function represents the entirety of the page content.\n", "\t" . '$helper = new onWord_helper();' . "\n", FILE_APPEND);
         file_put_contents("$class_dir/views/$method.php", "\t" . '$output = "";', FILE_APPEND);
      }
      $signature .= "\n\t\t}\n";

      //write the function signature
      $contents = file_get_contents("$class_dir/$class.php");
      $index = strrpos($contents, "}");
      $pre = substr($contents, 0, $index);
      $contents = $pre . "\n\n\n$signature}";
      file_put_contents("$class_dir/$class.php", $contents);

      echo "<p><strong>$method added to $class in $class_dir/$class.php</strong></p>";
   }

   if (!empty($_GET["method"]) || !empty($_POST)) {
      //if we're loading this page fresh, we need to create some basic variables
      if (!empty($_GET["method"])) {
         $plugin = $_GET["plugin"];
         $plugin_dir = ABSPATH . "wp-content/plugins/$plugin";
         $class = $_GET["class"];
         $method = $_GET["method"];
      }
      $url = get_site_url();
      //show the navigation for the method component generators
      echo "<h1>$method</h1>";

      //shortcode
      echo "<p><h2>Shortcode</h2>";
      echo "<ul>";
      $lines = file("$plugin_dir/shortcodes.php");
      $found = false;
      foreach ($lines as $line) {
         if (strpos($line, "'" . $class . "_" . $method . "'") !== false) {
            $offset = strpos($line, "('") + 2;
            $length = strrpos($line, "',") - $offset;
            $code = substr($line, $offset, $length);
            $found = true;
            break;
         }
      }
      if ($found) {
         echo "<li><a href='$url/wp-admin/admin.php?page=onWord_top_level_menu&onWord_page=shortcode&plugin=$plugin&class=$class&method=$method&shortcode=$code'>$code</a></li>";
      }
      else {
         echo "<li><a href='$url/wp-admin/admin.php?page=onWord_top_level_menu&onWord_page=shortcode&plugin=$plugin&class=$class&method=$method'>Create Shortcode</a></li>";
      }

      echo "</ul>";
      echo"</p>";

      //Return Navigation
      echo "<p><h2>Back</h2>";
      echo "<ul>";
      echo "<li><a href='$url/wp-admin/admin.php?page=onWord_top_level_menu&onWord_page=class&plugin=$plugin&class=$class'>Class: $class</a></li>";
      echo "<li><a href='$url/wp-admin/admin.php?page=onWord_top_level_menu&onWord_page=plugin&plugin=$plugin'>Plugin: $plugin</a></li>";
      echo "<li><a href='$url/wp-admin/admin.php?page=onWord_top_level_menu'>Plugins</a></li>";
      echo "</ul>";
      echo"</p>";
   }

   else {
      //show the method creation screen
      echo "<h1>Create New Method</h1>";
      echo "<form method='POST' action='#'>";
      echo "<table>";
      echo "<tr>";
      echo "<td><strong>Method Name</strong></td>";
      echo "<td><input type='text' name='method' /></td>";
      echo "</tr>";
      echo "<tr>";
      echo "<td><strong>Visibility</strong></td>";
      echo "<td>";
      echo "<select name='visibility'>";
      echo "<option value='public'>Public</option>";
      echo "<option value='private'>Private</option>";
      echo "<option value='protected'>Protected</option>";
      echo "</select>";
      echo "</td>";
      echo "</tr>";
      echo "<tr>";
      echo "<td><strong>Scope</strong></td>";
      echo "<td>";
      echo "<select name='scope'>";
      echo "<option value=''>Instance</option>";
      echo "<option value=' static'>Static</option>";
      echo "</select>";
      echo "</td>";
      echo "</tr>";
      echo "<tr>";
      echo "<td><strong>Arguments</strong></td>";
      echo "<td>";
      echo "<textarea name='arguments' onClick='if (this.value = \"$instructions\") {this.value=\"\";}'>$instructions</textarea>";
      echo "</td>";
      echo "</tr>";
      echo "<tr>";
      echo "<td><strong>Type</strong></td>";
      echo "<td>";
      echo "<select name='type'>";
      echo "<option value='action'>Action</option>";
      echo "<option value='view'>View</option>";
      echo "</select>";
      echo "</td>";
      echo "</tr>";
      echo "</table>";
      echo "<input type='submit' name='generate' value='Create' />";
      echo "</form>";
   }
?>