<?php
   if (!empty($_POST)) {
      //generate our plugin
      $plugin_name = $_POST["plugin_name"];
      $plugin = (empty($_POST["plugin_slug"]))
			? slugify($plugin_name)
			: $_POST["plugin_slug"];
      $plugin_dir = ABSPATH . "wp-content/plugins/$plugin";
      $onWord_dir = ABSPATH . "wp-content/plugins/onWord";

      //create the directory structure
      mkdir($plugin_dir);
      mkdir("$plugin_dir/admin_pages");
      mkdir("$plugin_dir/ajax");
      mkdir("$plugin_dir/classes");
      mkdir("$plugin_dir/classes/onWord_helper");
      mkdir("$plugin_dir/classes/onWord_object");
      mkdir("$plugin_dir/classes/onWord_query");
      mkdir("$plugin_dir/classes/onWord_helper/scripts");
      mkdir("$plugin_dir/classes/onWord_helper/styles");
      make_stub("$plugin_dir/menus.php");
      make_stub("$plugin_dir/content_types.php");
      make_stub("$plugin_dir/shortcodes.php");
      make_stub("$plugin_dir/pages.php");
      make_stub("$plugin_dir/schedules.php");
      file_put_contents("$plugin_dir/pages.php", '$page = array();', FILE_APPEND);

      //load the plugin skeleton
      $skeleton = file_get_contents("$onWord_dir/skeleton/plugin.php");
      $skeleton = str_replace("[plugin_name]", $plugin_name, $skeleton);
		$skeleton = str_replace("[plugin]", $plugin, $skeleton);
      file_put_contents("$plugin_dir/$plugin.php", $skeleton);

      //load the installer skeleton
      $skeleton = file_get_contents("$onWord_dir/skeleton/installer.php");
      $skeleton = str_replace("[plugin]", $plugin, $skeleton);
      file_put_contents("$plugin_dir/installer.php", $skeleton);

		//generate an api key
		$api_key = md5(time() . $_SERVER["SERVER_ADDR"]);

		//load the AJAX skeleton
      $skeleton = file_get_contents("$onWord_dir/skeleton/ajax.js");
      $skeleton = str_replace("[api_key]", $api_key, $skeleton);
      file_put_contents("$plugin_dir/ajax/ajax.js", $skeleton);
      $skeleton = file_get_contents("$onWord_dir/skeleton/ajax.php");
      $skeleton = str_replace("[api_key]", $api_key, $skeleton);
      file_put_contents("$plugin_dir/ajax/ajax.php", $skeleton);

      //copy the runtime libraries
      copy("$onWord_dir/lib/api.php", "$plugin_dir/api.php");
      copy("$onWord_dir/lib/calendar.css", "$plugin_dir/classes/onWord_helper/styles/calendar.css");
      copy("$onWord_dir/lib/calendar.js", "$plugin_dir/classes/onWord_helper/scripts/calendar.js");
      copy("$onWord_dir/lib/onWord_helper.php", "$plugin_dir/classes/onWord_helper/onWord_helper.php");
		copy("$onWord_dir/lib/recaptchalib.php", "$plugin_dir/classes/onWord_helper/recaptchalib.php");
      copy("$onWord_dir/lib/onWord_object.php", "$plugin_dir/classes/onWord_object/onWord_object.php");
      copy("$onWord_dir/lib/onWord_query.php", "$plugin_dir/classes/onWord_query/onWord_query.php");

      echo "<p><strong>Plugin created at $plugin_dir/$plugin.php</strong></p>";
   }

   if (!empty($_GET["plugin"]) || !empty($_POST)) {
      //if we're loading this page fresh, we need to create some basic variables
      if (!empty($_GET["plugin"])) {
         $plugin = $_GET["plugin"];
         $plugin_dir = ABSPATH . "wp-content/plugins/$plugin";
      }
      $url = get_site_url();
      //show the navigation for the plugin component generators
      echo "<h1>$plugin</h1>";

      //classes
      echo "<p><h2>Classes</h2>";
      echo "<ul>";
      echo "<li><a href='$url/wp-admin/admin.php?page=onWord_top_level_menu&onWord_page=class&plugin=$plugin'>Create Class</a></li>";
      $contents = scandir("$plugin_dir/classes/");
      foreach ($contents as $dir) {
         if ($dir != "." && $dir != ".." && is_dir("$plugin_dir/classes/$dir")) {
            echo "<li><a href='$url/wp-admin/admin.php?page=onWord_top_level_menu&onWord_page=class&plugin=$plugin&class=$dir'>$dir</a></li>";
         }
      }
      echo "</ul>";
      echo"</p>";

      //Admin Menus
      echo "<p><h2>Admin Menus</h2>";
      echo "<ul>";
      echo "<li><a href='$url/wp-admin/admin.php?page=onWord_top_level_menu&onWord_page=admin_menu&plugin=$plugin'>Create Admin Menu</a></li>";
      $lines = file("$plugin_dir/menus.php");
      foreach ($lines as $line) {
         if (strpos($line, "add_action('admin_menu'") !== false) {
            $line = explode(",", $line);
            $line = $line[1];
            $offset = strpos($line, "'") + 1;
            $length = strrpos($line, "'") - $offset;
            $menu = substr($line, $offset, $length);
            echo "<li><a href='$url/wp-admin/admin.php?page=onWord_top_level_menu&onWord_page=admin_menu&plugin=$plugin&menu=$menu'>$menu</a></li>";
         }
      }
      echo "</ul>";
      echo"</p>";

      //Scheduled Items
      echo "<p><h2>Scheduled Items</h2>";
      echo "<ul>";
      echo "<li><a href='$url/wp-admin/admin.php?page=onWord_top_level_menu&onWord_page=schedule&plugin=$plugin'>Create Scheduled Item</a></li>";
      $lines = file("$plugin_dir/schedules.php");
      foreach ($lines as $line) {
         if (strpos($line, "wp_next_scheduled") !== false) {
            $offset = strpos($line, "'") + 1;
            $length = strrpos($line, "'") - $offset;
            echo "<li>" . substr($line, $offset, $length) . "</li>";
         }
      }
      echo "</ul>";
      echo"</p>";

      //Return Navigation
      echo "<p><h2>Back</h2>";
      echo "<ul>";
      echo "<li><a href='$url/wp-admin/admin.php?page=onWord_top_level_menu'>Plugins</a></li>";
      echo "</ul>";
      echo"</p>";
   }

   else {
      //show the plugin creation screen
      echo "<h1>Create New Plugin</h1>";
      echo "<form method='POST' action='#'>";
      echo "<table>";
      echo "<tr>";
      echo "<td><strong>Plugin Name</strong></td>";
      echo "<td><input type='text' name='plugin_name' /></td>";
      echo "</tr>";
      echo "<tr>";
      echo "<td><strong>Plugin Slug</strong></td>";
      echo "<td><input type='text' name='plugin_slug' /></td>";
      echo "</tr>";
      echo "</table>";
      echo "<input type='submit' name='generate' value='Create' />";
      echo "</form>";
   }
?>