<?php
   $instructions = "Comma separated list of attributes accepted by this shortcode.  Whitespace-insensitive.";
   if (!empty($_POST)) {
      //generate our shortcode
      $plugin = $_GET["plugin"];
      $class = $_GET["class"];
      $method = $_GET["method"];
      $function = $class . "_" . $method;
      $shortcode = slugify($_POST["shortcode"]);
      if ($_POST["attributes"] == $instructions || empty($_POST["attributes"])) {
         $attributes = "";
      }
      else {
         $attributes = explode(",", $_POST["attributes"]);
         foreach ($attributes as $index=>$attribute) {
            $attributes[$index] = slugify(trim($attribute)) . " => ''";
         }
         $attributes = implode(",\n\t\t\t", $attributes);
      }
      $plugin_dir = ABSPATH . "wp-content/plugins/$plugin";
      $onWord_dir = ABSPATH . "wp-content/plugins/onWord";

      //load the shortcode skeleton
      $skeleton = file_get_contents("$onWord_dir/skeleton/shortcode.php");
      $skeleton = str_replace("[function]", $function, $skeleton);
      $skeleton = str_replace("[attributes]", $attributes, $skeleton);
      $skeleton = str_replace("[shortcode]", $shortcode, $skeleton);
      file_put_contents("$plugin_dir/shortcodes.php", "\n$skeleton", FILE_APPEND);

      echo "<p><strong>Shortcode $shortcode created in $plugin_dir/shortcodes.php</strong></p>";
   }

   if (!empty($_GET["shortcode"]) || !empty($_POST)) {
      //if we're loading this page fresh, we need to create some basic variables
      if (!empty($_GET["shortcode"])) {
         $plugin = $_GET["plugin"];
         $plugin_dir = ABSPATH . "wp-content/plugins/$plugin";
         $class = $_GET["class"];
         $method = $_GET["method"];
         $shortcode = $_GET["shortcode"];
      }
      $url = get_site_url();
      //show the navigation for the class component generators
      echo "<h1>$shortcode</h1>";

      //page
      echo "<p><h2>Page</h2>";
      echo "<ul>";
      include("$plugin_dir/pages.php");
      $found = false;
      foreach ($pages as $trigger=>$route) {
         if ($trigger == "$class:$method") {
            $page = $route["slug"];
            $found = true;
            break;
         }
      }
      if ($found) {
         echo "<li>$page</li>";
      }
      else {
         echo "<li><a href='$url/wp-admin/admin.php?page=onWord_top_level_menu&onWord_page=page&plugin=$plugin&class=$class&method=$method&shortcode=$shortcode'>Create Page</a></li>";
      }

      //Return Navigation
      echo "<p><h2>Back</h2>";
      echo "<ul>";
      echo "<li><a href='$url/wp-admin/admin.php?page=onWord_top_level_menu&onWord_page=method&plugin=$plugin&class=$class&method=$method'>Method: $method</a></li>";
      echo "<li><a href='$url/wp-admin/admin.php?page=onWord_top_level_menu&onWord_page=class&plugin=$plugin&class=$class'>Class: $class</a></li>";
      echo "<li><a href='$url/wp-admin/admin.php?page=onWord_top_level_menu&onWord_page=plugin&plugin=$plugin'>Plugin: $plugin</a></li>";
      echo "<li><a href='$url/wp-admin/admin.php?page=onWord_top_level_menu'>Plugins</a></li>";
      echo "</ul>";
      echo"</p>";
   }


   else {
      //show the shortcode creation screen
      echo "<h1>Create New Shortcode</h1>";
      echo "<form method='POST' action='#'>";
      echo "<table>";
      echo "<tr>";
      echo "<td><strong>Shortcode</strong></td>";
      echo "<td><input type='text' name='shortcode' /></td>";
      echo "</tr>";
      echo "<tr>";
      echo "<td><strong>Attributes</strong></td>";
      echo "<td>";
      echo "<textarea name='attributes' onClick='if (this.value = \"$instructions\") {this.value=\"\";}'>$instructions</textarea>";
      echo "</td>";
      echo "</tr>";
      echo "</table>";
      echo "<input type='submit' name='generate' value='Create' />";
      echo "</form>";
   }
?>