	//define our content type
	add_action('init', '[plugin]_create_[singular_name_slug]' );
	function [plugin]_create_[singular_name_slug]() {
		register_post_type('[plugin]_[singular_name_slug]',
			array(
				'labels' => array(
					'name' => __( '[plural_name]' ),
					'singular_name' => __( '[singular_name]' )
				),
				'public' => true,
				'has_archive' => true,
				'rewrite' => array (
					 'slug' => '[plural_name_slug]'
				),
				'taxonomies' => array (
					 "category",
					 "post_tag"
				)
			)
		);
	}



	//print a special meta box for this post type's options
	add_action('add_meta_boxes', 'add_[plugin]_[singular_name_slug]_options_box');
	function add_[plugin]_[singular_name_slug]_options_box() {
		add_meta_box("[plugin]_[singular_name_slug]_options_box", "[singular_name] Options", "[plugin]_[singular_name_slug]_options_box", "[plugin]_[singular_name_slug]", "normal");
	}

	function [plugin]_[singular_name_slug]_options_box() {
		// Use nonce for verification
		wp_nonce_field( plugin_basename( __FILE__ ), '[plugin]_[singular_name_slug]_noncename' );
		if (!empty($_GET["post"])) {
			//load the data for this object
			$post_id = $_GET["post"];
			$query = new onWord_query(array(
				 "class" => "[class]",
				 "key" => "post_id",
				 "operator" => "=",
				 "value" => $post_id
			));
			if ($query->search()) {
				$obj_id = $query->results[0];
				$obj = new [class]($obj_id);
			}
			else {
				$obj_id = 0;
				$obj = new [class]();
			}
		}
		else {
			//create new data
			$post_id = 0;
			$obj_id = 0;
			$obj = new [class]();
		}
		//print form elements to update the object data
		echo "<input type='hidden' name='obj_id' value='$obj_id' />";
	}



	//save the metabox data
	add_action('save_post', '[plugin]_[singular_name_slug]_save_data' );
	function [plugin]_[singular_name_slug]_save_data($post_id) {
		// verify if this is an auto save routine.
		// If it is our form has not been submitted, so we dont want to do anything
		if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE )
		  return;
		// verify this came from our screen and with proper authorization,
		// because save_post can be triggered at other times

		if ( !wp_verify_nonce( $_POST['[plugin]_[singular_name_slug]_noncename'], plugin_basename( __FILE__ ) ) )
		  return;

		// Check permissions
		if ( '[plugin]_[singular_name_slug]' == $_POST['post_type'] ) {
			if ( !current_user_can( 'edit_post', $post_id ) )
			return;
		}
		//only run this code during an actual post save
		if (wp_is_post_revision($post_id)) {
			return;
		}

		// OK, we're authenticated and we know the REAL post_id: we need to save the data
		$obj = new [class]($_POST["obj_id"]);
	}



	//cleanup after deletion
	add_action('before_delete_post', 'delete_[plugin]_[singular_name_slug]');
	function delete_[plugin]_[singular_name_slug]($post_id) {
		$query = new onWord_query(array(
				"class" => "[class]",
				"key" => "post_id",
				"operator" => "=",
				"value" => $post_id
		));
		$query->search();
		$obj_id = $query->results[0];
		$obj = new [class]($obj_id);
	}
